#ifndef FILEBROWSER_H
#define FILEBROWSER_H

#include <qwidget.h>
#include <qprocess.h>

class FileIconView;
class QProgressBar;
class QLabel;
class QComboBox;
class QToolButton;

class FileBrowser : public QWidget
{
    Q_OBJECT

public:
    FileBrowser( QWidget *parent = 0, const char *name = 0, WFlags f = 0);

    FileIconView *fileView() { return fileview; }

protected:
    void setPathCombo(const QString &path);

    FileIconView *fileview;

    QProgressBar *progress;
    QLabel *label;
    QComboBox *pathCombo;
    QToolButton *upButton, *mkdirButton;
    QProcess* process;

protected slots:
    void directoryChanged( const QString & );
    void startReadDir( int dirs );
    void readNextDir();
    void readDirDone();
    void cdUp();
    void newFolder();
    void changePath( const QString &path );
    void enableUp( const bool value );
    void enableMkdir( const bool value );
    void runCommand( const QString& command );
    void processExited();

};

#endif
