
#include <qpixmap.h>
#include <qfileinfo.h>
#include <qdir.h>

#include "pixmap.h"

static const char * file_icon[]={
    "32 32 17 1",
    "# c #000000",
    "a c #ffffff",
    "j c #808080",
    "n c #a0a0a4",
    "g c #c0c0c0",
    "m c #004000",
    "o c #000000",
    "l c #004040",
    "k c #404000",
    "i c #c0c000",
    "h c #ffff00",
    "b c #ffffc0",
    "e c #ff8000",
    "f c #c05800",
    "c c #ffa858",
    "d c #ffdca8",
    ". c None",
    "................................",
    "................................",
    "................................",
    "................................",
    ".............#....###...........",
    "...###......#a##.#aba##.........",
    "..#cdb#....#aaaa#aaaaaa##.......",
    "..#ecdb#..#aaaa#aaaaaaaba##.....",
    "..#fecdb##aaaa#aaaaaaaaaaab##...",
    "...#fecdb#aaa#aaaaaaabaabaaaa##.",
    "....#fecdb#a#baaaaa#baaaaaabaaa#",
    ".....#fecdb#aaaaab#a##baaaaaaa#.",
    ".....##fecdb#bbba#aaaa##baaab#..",
    "....#bb#fecdb#ba#aaaaaaa##aa#...",
    "...#bbbb#fecdb##aaabaaaaaa##....",
    "..#bbbb#b#fecdb#aaaaaaabaaaa##..",
    ".#bbbb#bbb#fecdg#aaaaaaaaaaaba#.",
    "#hhbb#bbbbb#fegg#iiaaaaaaaaaaaa#",
    "#jhhhklibbbk#ggj#aaiiaaaaaaaaa#j",
    ".#mjhhhkmikab####aaabiiaaaaaa#j.",
    "...##jhhhmaaibbaaiibaaaiiaab#n..",
    ".....##j#baaaiiabaaiibaabaa#n...",
    "......##baibaabiibaaaiiabb#j....",
    "......#bbbbiiaabbiiaaaaabon.....",
    ".....#bbbbbbbiiabbaiiaab#n......",
    ".....#jbbbbbbbbiibaabba#n.......",
    "......##jbbbbbbbbiiaabmj........",
    "........##jbbbbbbbbbb#j.........",
    "..........##nbbbbbbbmj..........",
    "............##jbbbb#j...........",
    "..............#mjj#n............",
    "................##n............."};

static const char* folder_icon[]={
"32 32 8 1",
"e c #cece63",
"f c #ffce9c",
"c c #ffff9c",
"a c #000000",
"d c #fffff7",
"  c None",
"b c #ffffff",
"# c #9c9c00",
"                                ",
"                                ",
"                                ",
"    #########a                  ",
"   #bcccccccc#a                 ",
"  #bcccccccccc#a                ",
" #dcccccccccccc#a               ",
"#eeeeeeeeeeeeeee##############  ",
"#bbbbbbbbbbbbbbbbbbbbbbbbbbbbba ",
"#bcccccccccccccccccccfccfcccfcea",
"#bcccccccccccccfcfcfcccfcccfcfea",
"#bccccccccccccccccccccfccffcccea",
"#bccccccccccccccccfcfcccfccccfea",
"#bccccccccccfcfcfccccccccfcfcfea",
"#bccccccccccccccccfcfcfcfcccfcea",
"#bccccccccfccccfcccccccfccffcfea",
"#bcccccccccccfccfcfccfccfcccfcea",
"#bccccccfcccccccccccfcfccffccfea",
"#bccccccccfcfcfcffcfccccfccffcea",
"#bccccfcccccccccccccfcffcfffcfea",
"#bccccccfcccfcfcfcfccfccfccfffea",
"#bcccccccccfcccccfcffcffcffcfcea",
"#bcfcfccfcfccfcfcccccffffcffffea",
"#bcccccccccfccfcffcffcccffffcfea",
"#bccfcfccfcccfcfccfccfffcfccffea",
"#bfcccccfccffccfcfccfffcffffffea",
"#bcccfcfccfccffcfcffccfffcffffea",
"#bfcfcfccfcfcccfcfccffcfcfffcfea",
"#eeeeeeeeeeeeeeeeeeeeeeeeeeeeeea",
" aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa ",
"                                ",
"                                "};

static const char*folder_locked_icon[]={
"32 32 15 1",
"h c #808080",
"e c #cece63",
"l c #ffa858",
"i c #ffce9c",
"c c #ffff9c",
"g c #c05800",
"f c #000000",
"d c #fffff7",
"a c #080808",
"j c #313100",
"m c #303030",
"k c #ffdca8",
"  c None",
"b c #ffffff",
"# c #9c9c00",
"                                ",
"                                ",
"                                ",
"    #########a                  ",
"   #bcccccccc#a                 ",
"  #bcccccccccc#a                ",
" #dcccccccccccc#a               ",
"#eeeeeeeeeeeeeeefffff#########  ",
"#bbbbbbbbbbbbbbbfgghfbbbbbbbbbf ",
"#bcccccccccccccfgghfciccicccicea",
"#bcccccccccccccfgghfccciccciciej",
"#bcccccccccccccfgghfccicciicccej",
"#bcccccccccccccfgghficccicccciej",
"#bccccccccccicifgghfccccciciciej",
"#bcccccccccccccfgghficicicccicej",
"#bccccccccicckkkkkkkkkcicciiciej",
"#bccccccccccclllllllllccicccicej",
"#bcccccciccccllfgghfllicciicciej",
"#bccccccccicillfgghfllccicciicej",
"#bcccciccccccllfgghflliiciiiciej",
"#bccccccicccillkkkkkllccicciiiej",
"#bcccccccccicllllllllliiciicicej",
"#bcicicciciccicfgghfciiiiciiiiej",
"#bccccccccciccifgghficcciiiiciej",
"#bcciciccicccicfgghfciiicicciiej",
"#bicccccicciiccfgghfiiiciiiiiiej",
"#bccciciccicciifgghfcciiiciiiiej",
"#biciciccicicccfgghfiiciciiiciej",
"#eeeeeeeeeeeeeefgghfeeeeeeeeeeej",
" jjjjjjjjjjjjjjfgghfjjjjjjjjjjj ",
"                mmm             ",
"                                "};

static const char * link_icon[]={
    "32 32 12 1",
    "# c #000000",
    "h c #a0a0a4",
    "b c #c00000",
    "d c #585858",
    "i c #400000",
    "c c #ffffff",
    "e c #000000",
    "g c #c0c0c0",
    "a c #ff0000",
    "f c #303030",
    "n c white",
    ". c None",
    "...###..........................",
    "...#aa##........................",
    ".###baaa##......................",
    ".#cde#baaa##....................",
    ".#cccdeebaaa##..##f.............",
    ".#cccccdeebaaa##aaa##...........",
    ".#cccccccdeebaaaaaaaa##.........",
    ".#cccccccccdeebababaaa#.........",
    ".#cccccgcgghhebbbbbbbaa#........",
    ".#ccccccgcgggdebbbbbbba#........",
    ".#cccgcgcgcgghdeebiebbba#.......",
    ".#ccccgcggggggghdeddeeba#.......",
    ".#cgcgcgcggggggggghghdebb#......",
    ".#ccgcggggggggghghghghd#b#......",
    ".#cgcgcggggggggghghghhd#b#......",
    ".#gcggggggggghghghhhhhd#b#......",
    ".#cgcggggggggghghghhhhd#b#......",
    ".#ggggggggghghghhhhhhhdib#......",
    ".#gggggggggghghghhhhhhd#b#......",
    ".#hhggggghghghhhhhhhhhd#b#......",
    ".#ddhhgggghghghhhhhhhhd#b#......",
    "..##ddhhghghhhhhhhhhhhdeb#......",
    "############hhhhhhhhhhd#b#......",
    "#nnnnnnnnnn#hhhhhhhhhhd#b#......",
    "#nnnnnnnnnn#hhhhhhhhhhd#b#......",
    "#nn#nn#nnnn#ddhhhhhhhhd#b#......",
    "#nn##n##nnn###ddhhhhhhd#b###....",
    "#nnn#####nn#..##ddhhhhd#b#####..",
    "#nnnnn##nnn#....##ddhhd#b######.",
    "#nnnnn#nnnn#......##dddeb#####..",
    "#nnnnnnnnnn#........##d#b###....",
    "############..........####......"};

static const char * c_file_icon []={
"32 32 17 1",
"b c #808080",
"l c #c3c3c3",
"n c #000080",
"d c #fffff0",
"o c #c0c0ff",
"i c #f0f0f0",
"e c #9f9f9f",
"m c #0000c0",
"g c #e0e0d0",
"h c #303030",
"f c #cfcfcf",
"  c None",
"c c #505050",
"j c #efefef",
"k c #dcdcdc",
"a c #ffffff",
"# c #707070",
"    ##################          ",
"    #aaaaaaaaaaaaaaaabc         ",
"    #adddddddddddddddbec        ",
"    #adddddddddddddddbfec       ",
"    #adddddddddddddddbgfec      ",
"    #adddddddddddddddbagfec     ",
"    #adddddddddddddddchhhhhh    ",
"    #adddddaaaaddaddijklee#c    ",
"    #adddddddaaddadidijkleec    ",
"    #addddddddadddddiiijklec    ",
"    #addddddddadaddidiijjklc    ",
"    #addddddddddaaidiiijjjfc    ",
"    #adddddddddddddiiijjjgfc    ",
"    #adddddddkkkkdidijijggfc    ",
"    #addddddkmmmmnbiiijjjgfc    ",
"    #adddddkmmmmmmnbijjjggfc    ",
"    #addddkomnbddmnbjijgjgfc    ",
"    #addddkmnbdddooiijjjggfc    ",
"    #addddkmnbaiddiijjjgggfc    ",
"    #addddkmnbadddijijgjggfc    ",
"    #addddkmnbadddjijgjgggfc    ",
"    #addddkmnbaddoojjjggggfc    ",
"    #addddkonnbddmnbjgggggfc    ",
"    #addiddkmmmmmmnbgjggggfc    ",
"    #adidddakmmmmnbgjgjgggfc    ",
"    #adddidiikkkkjjjgjggggfc    ",
"    #aididijiijjjgjgjgggggfc    ",
"    #adidijijjgjgjgjggggggfc    ",
"    #aiiijijggjgjgggggggggfc    ",
"    #jjjjjjgjgggggggggggggfc    ",
"    #ffffffffffffffffffffffc    ",
"    #ccccccccccccccccccccccc    "};

static const char * cpp_file_icon[]={
"32 32 17 1",
"b c #808080",
"l c #c3c3c3",
"n c #000080",
"d c #fffff0",
"o c #c0c0ff",
"i c #f0f0f0",
"e c #9f9f9f",
"m c #0000c0",
"g c #e0e0d0",
"h c #303030",
"f c #cfcfcf",
"  c None",
"c c #505050",
"j c #efefef",
"k c #dcdcdc",
"a c #ffffff",
"# c #707070",
"    ##################          ",
"    #aaaaaaaaaaaaaaaabc         ",
"    #adddddddddddddddbec        ",
"    #adddddddddddddddbfec       ",
"    #adddddddddddddddbgfec      ",
"    #adddddddddddddddbagfec     ",
"    #adddddddddddddddchhhhhh    ",
"    #adddddaaaaddaddijklee#c    ",
"    #adddddddaaddadidijkleec    ",
"    #addddddddadddddiiijklec    ",
"    #addddddddadaddidiijjklc    ",
"    #addddddddddaaidiiijjjfc    ",
"    #adddddddddddddiiijjjgfc    ",
"    #adddkkkkdidddidijijggfc    ",
"    #addkmmmmnbiddddiijjjgfc    ",
"    #adkmmmmmmnbddddijjjggfc    ",
"    #akomnbddmnbddddjijgjgfc    ",
"    #akmnbdddooidmniijnmggfc    ",
"    #akmnbaiddiidmndjjnmggfc    ",
"    #akmnbadddimmnnnmnnnmmfc    ",
"    #akmnbadddjnnnnnmnnnnnfc    ",
"    #akmnbaddoojdnmjjjnmggfc    ",
"    #akonnbddmnbdnmdjgnmggfc    ",
"    #adkmmmmmmnbddddgjggggfc    ",
"    #adakmmmmnbgdddgjgjgggfc    ",
"    #adddidiikkkkjgjgjggggfc    ",
"    #aididijiijjjgjgjgggggfc    ",
"    #adidijijjgjgjgjggggggfc    ",
"    #aiiijijggjgjgggggggggfc    ",
"    #jjjjjjgjgggggggggggggfc    ",
"    #ffffffffffffffffffffffc    ",
"    #ccccccccccccccccccccccc    "};

static const char * h_file_icon[]={
"32 32 16 1",
"b c #808080",
"l c #c3c3c3",
"d c #fffff0",
"m c #ffc0c0",
"i c #f0f0f0",
"e c #9f9f9f",
"g c #e0e0d0",
"h c #303030",
"f c #cfcfcf",
"  c None",
"c c #505050",
"j c #efefef",
"k c #dcdcdc",
"a c #ffffff",
"n c #ff0000",
"# c #707070",
"    ##################          ",
"    #aaaaaaaaaaaaaaaabc         ",
"    #adddddddddddddddbec        ",
"    #adddddddddddddddbfec       ",
"    #adddddddddddddddbgfec      ",
"    #adddddddddddddddbagfec     ",
"    #adddddddddddddddchhhhhh    ",
"    #adddddaaaaddaddijklee#c    ",
"    #adddddddaaddadidijkleec    ",
"    #addddddddadddddiiijklec    ",
"    #addddddddadaddidiijjklc    ",
"    #adddddddddddaaiiiijjjfc    ",
"    #adddddjmmddddddiijjjgfc    ",
"    #adddddjnnmddddiijijggfc    ",
"    #adddddjnnmddjddiijjjgfc    ",
"    #adddddjnnmdddddijjjggfc    ",
"    #adddddjnnmddjddjijgjgfc    ",
"    #adddddjnnnnnmddijjjggfc    ",
"    #adddddjnnnnnnmijjjgggfc    ",
"    #adddddjnnmdjnnmijgjggfc    ",
"    #adddddjnnmdjnnmjgjgggfc    ",
"    #adddddjnnmdjnnmjjggggfc    ",
"    #adddjdjnnmdjnnmjgggggfc    ",
"    #addiddjnnmdjnnmgjggggfc    ",
"    #adiddjjnnmdjnnmjgjgggfc    ",
"    #adddiddmmdddmmjgjggggfc    ",
"    #aididijijjjjgjgjgggggfc    ",
"    #adidijijjgjgjgjggggggfc    ",
"    #aiiijijggjgjgggggggggfc    ",
"    #jjjjjjgjgggggggggggggfc    ",
"    #ffffffffffffffffffffffc    ",
"    #ccccccccccccccccccccccc    "};

static const char * if_file_icon[]={
"32 32 7 1",
"# c #808080",
"d c #c3c3c3",
"b c #000000",
"c c #303030",
"  c None",
". c #ffffff",
"e c #ff0000",
"    ##################          ",
"    #................#b         ",
"    #................##b        ",
"    #................#d#b       ",
"    #................#.d#b      ",
"    #................#..d#b     ",
"    #................#bbbbbb    ",
"    #.....................db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #....eeeee..eeeeeeee..db    ",
"    #....eeeee..eeeeeeee..db    ",
"    #.....ee.....ee.......db    ",
"    #.....ee.....ee.......db    ",
"    #.....ee.....eeeee....db    ",
"    #....ee.....eeeeee....db    ",
"    #....ee.....ee........db    ",
"    #....ee.....ee........db    ",
"    #..eeeee...eeee.......db    ",
"    #..eeeee...eeee.......db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #ddddddddddddddddddddddb    ",
"    bbbbbbbbbbbbbbbbbbbbbbbb    "};

static const char * m4_file_icon[]={
"32 32 7 1",
"# c #808080",
"d c #c3c3c3",
"b c #000000",
"c c #303030",
"  c None",
". c #ffffff",
"e c #ff0000",
"    ##################          ",
"    #................#b         ",
"    #................##b        ",
"    #................#d#b       ",
"    #................#.d#b      ",
"    #................#..d#b     ",
"    #................#bbbbbb    ",
"    #.....................db    ",
"    #................bb...db    ",
"    #............bb..bb...db    ",
"    #............bb..bb...db    ",
"    #............bb..bb...db    ",
"    #............bbbbbbb..db    ",
"    #.............bbbbbb..db    ",
"    #...bbb..bbbb....bb...db    ",
"    #...bbbb.bbbbb...bb...db    ",
"    #..bb...bb...bb..bb...db    ",
"    #..bb...bb...bb.......db    ",
"    #..bb...bb...bb.......db    ",
"    #..bb...bb...bb.......db    ",
"    #..bb...bb...bb.......db    ",
"    #..bb...bb...bb.......db    ",
"    #.bbb..bbb..bbbb......db    ",
"    #.bbb..bbb..bbbb......db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #.....................db    ",
"    #ddddddddddddddddddddddb    ",
"    bbbbbbbbbbbbbbbbbbbbbbbb    "};

static const char * x_file_icon[]={
"32 32 7 1",
"# c #808080",
"d c #c3c3c3",
"b c #000000",
"c c #303030",
"  c None",
". c #ffffff",
"e c #0000ff",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"          eedd                  ",
"          eedd   eedd           ",
"           eedd  eedd           ",
"            eeddeedd            ",
"             eeeedd             ",
"              eedd              ",
"             eeeedd             ",
"            eeddeedd            ",
"           eedd  eedd           ",
"           eedd   eedd          ",
"                  eedd          ",
"                                ",
"                                ",
"                                ",
"                                "};

static const char * aut_file_icon[]={
"32 32 7 1",
"# c #808080",
"d c #c3c3c3",
"b c #000000",
"c c #303030",
"  c None",
". c #ffffff",
"e c #0000ff",
"   ###################          ",
"   #.................#b         ",
"   #.................##b        ",
"   #.................#d#b       ",
"   #.................#.d#b      ",
"   #.................#..d#b     ",
"   #.................#...d#b    ",
"   #.................#bbbbbbb   ",
"   #.......................db   ",
"   #.......................db   ",
"   #.......................db   ",
"   #.......................db   ",
"   #.......................db   ",
"   #.......................db   ",
"   #...eeee..ee..ee.eeeeee.db   ",
"   #...eeee..ee..ee.eeeeee.db   ",
"   #..ee..ee.ee..ee...ee...db   ",
"   #..ee..ee.ee..ee...ee...db   ",
"   #..eeeeee.ee..ee...ee...db   ",
"   #..eeeeee.ee..ee...ee...db   ",
"   #..ee..ee.eeeeee...ee...db   ",
"   #..ee..ee..eeee....ee...db   ",
"   #.......................db   ",
"   #.......................db   ",
"   #.......................db   ",
"   #.......................db   ",
"   #.......................db   ",
"   #.......................db   ",
"   #.......................db   ",
"   #.......................db   ",
"   #ddddddddddddddddddddddddb   ",
"   bbbbbbbbbbbbbbbbbbbbbbbbbb   "};

static const char * dvi_file_icon[]={
"32 32 16 1",
"b c #808080",
"n c #c3c3c3",
"d c #fffff0",
"j c #c0c0ff",
"k c #f0f0f0",
"e c #9f9f9f",
"i c #0000c0",
"g c #e0e0d0",
"h c #303030",
"f c #cfcfcf",
"  c None",
"c c #505050",
"l c #efefef",
"m c #dcdcdc",
"a c #ffffff",
"# c #707070",
"    ##################          ",
"    #aaaaaaaaaaaaaaaabc         ",
"    #adddddddddddddddbec        ",
"    #adddddddddddddddbfec       ",
"    #adddddddddddddddbgfec      ",
"    #adddddddddddddddbagfec     ",
"    #adddddddddddddddchhhhhh    ",
"    #adddijijajijijdklmnee#c    ",
"    #adddijiijijijijiklmneec    ",
"    #adddijiiijijijiiiklmnec    ",
"    #adddjiijaaaaddkiijijmnc    ",
"    #adddijaaiiaiikajiijllfc    ",
"    #adddiaaijjajjikijillgfc    ",
"    #adddijijiijiikdjiklggfc    ",
"    #adddijijiijiidkijlllgfc    ",
"    #adddijijjaajikkjiilggfc    ",
"    #adddiaaiiaiiaakijlglgfc    ",
"    #addiaaaaaaaaakijijlggfc    ",
"    #adijaaaaaikaakjljigggfc    ",
"    #adijiiaiiaaaakiijglggfc    ",
"    #adiajiiijaaailkjilgggfc    ",
"    #adijajjjaaiidkillggggfc    ",
"    #addiiiiiiiddkailgggggfc    ",
"    #addijdddaadjiklglggggfc    ",
"    #adkdijaaajiiklglglgggfc    ",
"    #adddkiiiiilklllglggggfc    ",
"    #akdkdklkklllglglgggggfc    ",
"    #adkdklkllglglglggggggfc    ",
"    #akkklklgglglgggggggggfc    ",
"    #llllllglgggggggggggggfc    ",
"    #ffffffffffffffffffffffc    ",
"    #ccccccccccccccccccccccc    "};

static const char * html_file_icon []={
"32 32 26 1",
"b c #808080",
"w c #008000",
"l c #c3c3c3",
"x c #000080",
"q c #00ff00",
"t c #bebabe",
"d c #fffff0",
"h c #beb6be",
"k c #000000",
"m c #f0f0f0",
"e c #9f9f9f",
"v c #0000c0",
"g c #e0e0d0",
"p c #c0ffc0",
"i c #6986be",
"j c #303030",
"f c #cfcfcf",
"s c #0000ff",
"  c None",
"c c #505050",
"n c #efefef",
"r c #00c000",
"o c #dcdcdc",
"a c #ffffff",
"u c #00c0c0",
"# c #707070",
"     ##################         ",
"     #aaaaaaaaaaaaaaaabc        ",
"     #adddddddddddddddbec       ",
"     #adddddddddddddddbfec      ",
"     #adddddddddddddddbgfec     ",
"     #adddhihhihhihiddbagfec    ",
"     #adddddddddddddddcjjjjjj   ",
"     kkkkkklaaaaddaddmnolee#c   ",
"   kkpqpprskk aihhithihnoleec   ",
"  kussrqqrssvk adddddmmmnolec   ",
" kussssrrrvssvkadaddmdmmnnolc   ",
" kussssrrsvvvvkldihhihihhinfc   ",
"kqrsssssssvsvvvkddddmmmnnngfc   ",
"kqqrsssssvsvvvvkdddmdmnmnggfc   ",
"kqqqrssssvsvrqrkdhihhihhihgfc   ",
"kqqqrsssvvvvqqrkdddmmmnnnggfc   ",
"kqqqqrssvswqqrwkddddmnmngngfc   ",
" kqrrrsvvvqqqrkldihihhihhigfc   ",
" krrssssvvqqrwkamddmmnnngggfc   ",
"  krssssvxrwwk adddmnmngnggfc   ",
"   kksxxxxwkk aaihihhihihigfc   ",
"     kkkkkklaaaadddmnnnggggfc   ",
"     #addddddddddddddgdggggfc   ",
"     #addmdddihihhihhihhihgfc   ",
"     #admdddaaaamnmngngngggfc   ",
"     #adddmdmmnmnmnnngnggggfc   ",
"     #amdmdmnmmnnngngngggggfc   ",
"     #admdmnmnngngngnggggggfc   ",
"     #ammmnmnggngngggggggggfc   ",
"     #nnnnnngngggggggggggggfc   ",
"     #ffffffffffffffffffffffc   ",
"     #ccccccccccccccccccccccc   "};

static const char * java_file_icon[]={
"32 32 23 1",
"b c #808080",
"h c #ffa858",
"n c #c3c3c3",
"r c #000080",
"d c #fffff0",
"u c #c05800",
"t c #c0c0ff",
"p c #f0f0f0",
"i c #ff8000",
"e c #9f9f9f",
"g c #e0e0d0",
"j c #303030",
"s c #800000",
"f c #cfcfcf",
"o c #ffdca8",
"q c #ffffc0",
"  c None",
"c c #505050",
"l c #efefef",
"m c #dcdcdc",
"a c #ffffff",
"k c #ff0000",
"# c #707070",
"   ###################          ",
"   #aaaaaaaaaaaaaaaaabc         ",
"   #addddddddddddddddbec        ",
"   #addddddddddddddddbfec       ",
"   #addddddddddddddddbgfec      ",
"   #addddddddddhhddddbagfec     ",
"   #addddddddddddidddcjjjjjj    ",
"   #addddaaddddhikdddlmnee#c    ",
"   #addddddddhkohodddplmneec    ",
"   #addddddihdhdiddddpplmnec    ",
"   #adddddhodhqhoddddppllmnc    ",
"   #addddohdkodikdddppplllfc    ",
"   #addddhqdhddohoddpplllgfc    ",
"   #addddiorrhrrrhrdplplggfc    ",
"   #adddrrhaahaaqhrrlrrrfgfc    ",
"   #addraaohssishoplrrtrrgfc    ",
"   #addrausshssshssprgltrgfc    ",
"   #addrrrssssshssrrrlgrrgfc    ",
"   #addraarrrrrrrrllrgrrfgfc    ",
"   #addraaaaatatttplrtggfgfc    ",
"   #adddraaaaatattlrldlgggfc    ",
"   #addddrtaaaatatrlglggggfc    ",
"   #adddtdrttaaatrltggdgggfc    ",
"   #addrtdarrrrrragtrdggggfc    ",
"   #addrttaaaaaaaattrgggggfc    ",
"   #adddrrttttttttrrggggggfc    ",
"   #appdplrrrrrrrrlgggggggfc    ",
"   #addpdplpllglglglggggggfc    ",
"   #apppplplgglglgggggggggfc    ",
"   #lllllllglgggggggggggggfc    ",
"   #fffffffffffffffffffffffc    ",
"    #ccccccccccccccccccccccc    "};

static const char * make_file_icon[]={
"32 32 20 1",
"b c #808080",
"o c #ffa858",
"n c #a0a0a0",
"l c #c3c3c3",
"d c #fffff0",
"m c #000000",
"i c #f0f0f0",
"e c #9f9f9f",
"g c #e0e0d0",
"h c #303030",
"f c #cfcfcf",
"p c #ffdca8",
"q c #ffffc0",
"  c None",
"c c #505050",
"r c #585858",
"j c #efefef",
"k c #dcdcdc",
"a c #ffffff",
"# c #707070",
"    ##################          ",
"    #aaaaaaaaaaaaaaaabc         ",
"    #adddddddddddddddbec        ",
"    #adddddddddddddddbfec       ",
"    #adddddddddddddddbgfec      ",
"    #adddddddddddddddbagfec     ",
"    #adddddddddddddddchhhhhh    ",
"    #adddddaaaaddaddijklee#c    ",
"    #adddddddaaddadidijkleec    ",
"    #addddddddadddddiiijklec    ",
"    #addddddddadaddidiijjklc    ",
"    #adddaaaaaammaaaaaajjjfc    ",
"    #adddaammamkkmammaajjgfc    ",
"    #adddamknmnllnmnkmajggfc    ",
"    #adddamnkbnoonbknmajjgfc    ",
"    #adddaamboopopobmaajggfc    ",
"    #adddmmknopbbopnkmmgjgfc    ",
"    #addmklnoponnpqonlkmggfc    ",
"    #addmbnkbpqppaqbknbmggfc    ",
"    #adddmrrkbpqapbkrrmjggfc    ",
"    #adddamblkkbbkklbmagggfc    ",
"    #adddmnabrbkkbrbanmgggfc    ",
"    #adddmknrmmnnmmrnkmgggfc    ",
"    #addiammmamkamammmagggfc    ",
"    #adiddaaaamrbmaaaaagggfc    ",
"    #adddidiijimmjjjgjggggfc    ",
"    #aididijiijjjgjgjgggggfc    ",
"    #adidijijjgjgjgjggggggfc    ",
"    #aiiijijggjgjgggggggggfc    ",
"    #jjjjjjgjgggggggggggggfc    ",
"    #ffffffffffffffffffffffc    ",
"    #ccccccccccccccccccccccc    "};

static const char * o_file_icon[]={
"32 32 17 1",
"b c #808080",
"l c #c3c3c3",
"d c #fffff0",
"n c #00b3ff",
"m c #c0c0ff",
"i c #f0f0f0",
"e c #9f9f9f",
"g c #e0e0d0",
"o c #0066e3",
"h c #303030",
"f c #cfcfcf",
"  c None",
"c c #505050",
"j c #efefef",
"k c #dcdcdc",
"a c #ffffff",
"# c #707070",
"    ##################          ",
"    #aaaaaaaaaaaaaaaabc         ",
"    #adddddddddddddddbec        ",
"    #adddddddddddddddbfec       ",
"    #adddddddddddddddbgfec      ",
"    #adddddddddddddddbagfec     ",
"    #adddddddddddddddchhhhhh    ",
"    #adddddaaaaddaddijklee#c    ",
"    #adddddddaaddadidijkleec    ",
"    #addddddddadddddiiijklec    ",
"    #addddddddadaddidiijjklc    ",
"    #addddddddddaaidiiijjjfc    ",
"    #adddddddddddddiiijjjgfc    ",
"    #addddddddddddidijijggfc    ",
"    #adddddddddddddiiijjjgfc    ",
"    #addddddddddddiiijjjggfc    ",
"    #adddddddddddddiddjgjgfc    ",
"    #addddddddddddddijjjggfc    ",
"    #adddddddmnnnnmdjjjgggfc    ",
"    #addddddmnoooonmdjgjggfc    ",
"    #addddddnommmmonjgjgggfc    ",
"    #addddddnomadmonjjggggfc    ",
"    #addddddnomadmonjgggggfc    ",
"    #addidddnommmmongjggggfc    ",
"    #adiddddmnoooonmjgjgggfc    ",
"    #adddidaamnnnnmggjggggfc    ",
"    #aididijiijjjgjgjgggggfc    ",
"    #adidijijjgjgjgjggggggfc    ",
"    #aiiijijggjgjgggggggggfc    ",
"    #jjjjjjgjgggggggggggggfc    ",
"    #ffffffffffffffffffffffc    ",
"    #ccccccccccccccccccccccc    "};

static const char * l_file_icon[]={
"32 32 17 1",
"b c #808080",
"l c #c3c3c3",
"n c #000080",
"d c #fffff0",
"m c #c0c0ff",
"i c #f0f0f0",
"e c #9f9f9f",
"g c #e0e0d0",
"h c #303030",
"f c #cfcfcf",
"o c #0000ff",
"  c None",
"c c #505050",
"j c #efefef",
"k c #dcdcdc",
"a c #ffffff",
"# c #707070",
"    ##################          ",
"    #aaaaaaaaaaaaaaaabc         ",
"    #adddddddddddddddbec        ",
"    #adddddddddddddddbfec       ",
"    #adddddddddddddddbgfec      ",
"    #adddddddddddddddbagfec     ",
"    #adddddddddddddddchhhhhh    ",
"    #adddddaaaaddaddijklee#c    ",
"    #adddddddaaddadidijkleec    ",
"    #addddddddadddddiiijklec    ",
"    #addddddddadaddidiijjklc    ",
"    #addddddddddaaidiiijjjfc    ",
"    #adddddddddddddiiijjjgfc    ",
"    #addddddddddddidijijggfc    ",
"    #adddddddddddddiiijjjgfc    ",
"    #adddddddddmmdiiijjjggfc    ",
"    #addddddddmnomdijijgjgfc    ",
"    #addddddddmnomiiijjjggfc    ",
"    #addddddddmnomiijjjgggfc    ",
"    #addddddddmnomijijgjggfc    ",
"    #adddddddamnomjijgjgggfc    ",
"    #adddddaaamnomijjjggggfc    ",
"    #addddddddmnommjjgggggfc    ",
"    #addiddddamnooomgjggggfc    ",
"    #adidddaaammnnnmdgjgggfc    ",
"    #adddidiijimmmmdgjggggfc    ",
"    #aididijiijjjgjgjgggggfc    ",
"    #adidijijjgjgjgjggggggfc    ",
"    #aiiijijggjgjgggggggggfc    ",
"    #jjjjjjgjgggggggggggggfc    ",
"    #ffffffffffffffffffffffc    ",
"    #ccccccccccccccccccccccc    "};

static const char * y_file_icon[]={
"32 32 16 1",
"b c #808080",
"l c #c3c3c3",
"d c #fffff0",
"m c #ffc0c0",
"i c #f0f0f0",
"e c #9f9f9f",
"g c #e0e0d0",
"h c #303030",
"f c #cfcfcf",
"  c None",
"c c #505050",
"n c #c00000",
"j c #efefef",
"k c #dcdcdc",
"a c #ffffff",
"# c #707070",
"    ##################          ",
"    #aaaaaaaaaaaaaaaabc         ",
"    #adddddddddddddddbec        ",
"    #adddddddddddddddbfec       ",
"    #adddddddddddddddbgfec      ",
"    #adddddddddddddddbagfec     ",
"    #adddddddddddddddchhhhhh    ",
"    #adddddaaaaddaddijklee#c    ",
"    #adddddddaaddadidijkleec    ",
"    #addddddddadddddiiijklec    ",
"    #addddddddadaddidiijjklc    ",
"    #addddddddddaaidiiijjjfc    ",
"    #adddddddddddddiiijjjgfc    ",
"    #addddddddddddidijijggfc    ",
"    #adddddddddddddiiijjjgfc    ",
"    #addddddddddddiiijjjggfc    ",
"    #adddddddddddddijijgjgfc    ",
"    #adddddddmmddmmiijjjggfc    ",
"    #addddddmnnddnnmjjjgggfc    ",
"    #addddddmnnddnnmijgjggfc    ",
"    #addddddmnnddnnmjgjgggfc    ",
"    #adddddamnnmmnnmjjggggfc    ",
"    #adddddddmnnnnmjjgggggfc    ",
"    #addiddddmnnnnmjgjggggfc    ",
"    #adidddaaamnnmjgjgjgggfc    ",
"    #adddidddmmnnmjjgjggggfc    ",
"    #aididijmnnnmgjgjgggggfc    ",
"    #adidijijmmmgjgjggggggfc    ",
"    #aiiijijggjgjgggggggggfc    ",
"    #jjjjjjgjgggggggggggggfc    ",
"    #ffffffffffffffffffffffc    ",
"    #ccccccccccccccccccccccc    "};

static const char * pdf_file_icon[]={
"32 32 7 1",
"# c #808080",
"d c #c3c3c3",
"b c #000000",
"c c #303030",
"  c None",
". c #ffffff",
"e c #ff0000",
"    ##################          ",
"    #................#b         ",
"    #................##b        ",
"ccccccccccccccccccc..#d#b       ",
"cc...ccc...ccc....c..#.d#b      ",
"cc.cc.cc.cc.cc.cccc..#..d#b     ",
"cc...ccc.cc.cc...cc..#bbbbbb    ",
"cc.ccccc.cc.cc.cccc.......db    ",
"cc.ccccc...ccc.cccc.......db    ",
"ccccccccccccccccccc.......db    ",
"    #.........e...........db    ",
"    #........e.e..........db    ",
"    #........e.e#.........db    ",
"    #......#.e.e...#......db    ",
"    #........eee..........db    ",
"    #....#....ee.....#....db    ",
"    #.........ee..........db    ",
"    #.........eee.........db    ",
"    #...#....de.ee....#...db    ",
"    #........ee..eed......db    ",
"    #........ed....eeeeee.db    ",
"    #...#...de...eeeee...edb    ",
"    #.......ee.eee....eee.db    ",
"    #.......eeee..........db    ",
"    #....#.eed.......#....db    ",
"    #.....ee..............db    ",
"    #...eeee.......#......db    ",
"    #..ee.e..#..#.........db    ",
"    #..e..e...............db    ",
"    #...ee................db    ",
"    #ddddddddddddddddddddddb    ",
"    bbbbbbbbbbbbbbbbbbbbbbbb    "};

static const char * ps_file_icon[] = {
"32 32 5 1",
"       s None  c None",
".      c #808080",
"X      c #FFFFFF",
"o      c #c0c0c0",
"O      c #000000",
"    ...................         ",
"    .XXXXXoXXXXXXXXXXX.O        ",
"    .XXXXooo.XXXXXXXXX..O       ",
"    .XXXOoooO.XXXXXXXX.o.O      ",
"    .XXXXOoO...XXXXXXX.Xo.O     ",
"    .XoXXXO...oXXXXXXX.XXo.O    ",
"    .ooo.XXX.ooo.XXXXX.OOOOOO   ",
"    OoooO.XXOoooO.XXXXXXXXXoO   ",
"    .OoO...XXOoO...XXXXXXXXoO   ",
"  o .XO...oXXXO...oXXXXXXXXoO   ",
" ooo.XXX.ooo.XXX.ooo.XXXXXXoO   ",
"OoooO.XXOoooO.XXOoooO.XXXXXoO   ",
" OoO...XXOoO...XXOoO...XXXXoO   ",
"  Oo..oXXXO...oXXXO...XXXXXoO   ",
"    .ooo.XXX.ooo.XXX.XXXXXXoO   ",
"    OoooO.XXOoooO.XXXXXXXXXoO   ",
"    .OoO...XXOoO...XXXXXXXXoO   ",
"    .XO...oXXXO...XXXXXXXXXoO   ",
"    .XXX.ooo.XXX.XXXXXXXXXXoO   ",
"    .XXXOoooO.XXXXXXXXXXXXXoO   ",
"    .XXXXOoO...XXXXXXXXXXXXoO   ",
"    .XXXXXO...XXXXXXXXXXXXXoO   ",
"    .XXXXXXX.XXOOOOOXXXOOOXoO   ",
"    .XXXXXXXXXOXXOXOXXOXXOXoO   ",
"    .XXXXXXXXXOXOXXOXXOXXXXoO   ",
"    .XXXXXXXXXXXOOOXXXXOXXXoO   ",
"    .XXXXXXXXXXXOXXXXXXXOXXoO   ",
"    .XXXXXXXXXXOXXXXOXXXOXXoO   ",
"    .XXXXXXXXXOOOXXXXOOOXXXoO   ",
"    .XXXXXXXXXXXXXXXXXXXXXXoO   ",
"    .oooooooooooooooooooooooO   ",
"    OOOOOOOOOOOOOOOOOOOOOOOOO   "};

static const char * readme_file_icon[]={
"32 32 16 1",
"b c #808080",
"l c #c3c3c3",
"m c #000080",
"d c #fffff0",
"n c #c0c0ff",
"i c #f0f0f0",
"e c #9f9f9f",
"g c #e0e0d0",
"h c #303030",
"f c #cfcfcf",
"  c None",
"c c #505050",
"j c #efefef",
"k c #dcdcdc",
"a c #ffffff",
"# c #707070",
"       ##################       ",
"       #aaaaaaaaaaaaaaaabc      ",
"       #adddddddddddddddbec     ",
"       #adddddddddddddddbfec    ",
"       #adddddddddddddddbgfec   ",
"       #adddddddddddddddbagfec  ",
"       #adddddddddddddddchhhhhh ",
"       #adddddaaaaddaddijklee#c ",
"       #adddddddaaddadidijkleec ",
"       #addddddddadddddiiijklec ",
"       #addddddddadaddidiijjklc ",
"       #adddddddmmmmmmdiiijjjfc ",
"       #adddddmmmmmmmmmmijjjgfc ",
"       #addddmmmmnaanmmmmijggfc ",
"       #adddmmmmmnaanmmmmmjjgfc ",
"       #addmmmmmmmmmmmmmmmmggfc ",
"       #addmmmmmmmmmmmmmmmmjgfc ",
"       #admmmmmmaaaanmmmmmmmgfc ",
"       #admmmmmmmnaanmmmmmmmgfc ",
"       #admmmmmmmnaanmmmmmmmgfc ",
"       #admmmmmmmnaanmmmmmmmgfc ",
"       #admmmmmmmnaanmmmmmmmgfc ",
"       #addmmmmmmnaanmmmmmmggfc ",
"       #addmmmmmmnaanmmmmmmggfc ",
"       #adidmmmmmnaanmmmmmgggfc ",
"       #adddimmmaaaaaammmggggfc ",
"       #aididimmmmmmmmmmgggggfc ",
"       #adidijijmmmmmmjggggggfc ",
"       #aiiijijggjgjgggggggggfc ",
"       #jjjjjjgjgggggggggggggfc ",
"       #ffffffffffffffffffffffc ",
"       #ccccccccccccccccccccccc "};

static const char * zip_file_icon[] = {
/* width height num_colors chars_per_pixel */
"    32    32       61            1",
/* colors */
"  c none",
"# c #003028",
"a c #6196cf",
"b c #61cfcf",
"c c #96cfff",
"d c #61cfff",
"e c #28cfcf",
"f c #2896cf",
"g c #0096cf",
"h c #006196",
"i c #96cfcf",
"j c #cfefff",
"k c #61ffff",
"l c #ffffff",
"m c #f7f7f7",
"n c #a6cfef",
"o c #003061",
"p c #280000",
"q c #ffc78e",
"r c #ffcf96",
"s c #ffcf9e",
"t c #ffcfa6",
"u c #ffd7ae",
"v c #ffd7b6",
"w c #ffd7be",
"x c #ffdfc7",
"y c #ffdfcf",
"z c #ffdfd7",
"A c #000000",
"B c #969696",
"C c #cf9686",
"D c #182018",
"E c #080808",
"F c #cf8e79",
"G c #616161",
"H c #384138",
"I c #c78e71",
"J c #fff786",
"K c #fff78e",
"L c #fff796",
"M c #fff79e",
"N c #fff7a6",
"O c #fff7ae",
"P c #fff7b6",
"Q c #fff7be",
"R c #ffefcf",
"S c #c78669",
"T c #fff779",
"U c #ff6100",
"V c #be7961",
"W c #fff771",
"X c #fff769",
"Y c #be7159",
"Z c #fff761",
"0 c #b66949",
"1 c #b66141",
"2 c #fff759",
"3 c #ae5938",
"4 c #ffff51",
"5 c #003096",
"6 c #bedfbe",
/* pixels */
"      ##############            ",
"     #hggfebbdcccbba#           ",
"    #hgggfebbdccccbci#######    ",
"    oooooooooooooo#nmlkjcegg#   ",
"                   #jlkjcegg#   ",
"  pppppppppppppppp  #llmcbgg#   ",
" pzyxwwvuutssrrqpp   #######    ",
"pzyxwwvuttssrqqpCp    BAAAA     ",
"pppppppppppppppCFp   EEEEED     ",
"pRRQPOONMLLKJJpFIp   HHHGG      ",
"pRUUUUUUUUUUpTpISp    #jb#      ",
"pRUPONMMLKJTpWpSVp    BAAAA     ",
"pQUONAAAAAJTpXpVVp   EEEEED     ",
"pQUONMLKKJTWpXpVVp   HHHGG      ",
"pPpppppppppppZpVYp    #jb#      ",
"pPONMLKJJTWXZZpY0p    BAAAA     ",
"pPUUUUUUUUUUpZp01p   EEEEED     ",
"pOUMLKKJTWXZp2p01p   HHHGG      ",
"pOUMLAAAAAZZp2p13p    #jb#      ",
"pOUMLKJTWXZZp4p33p    #AAAA     ",
"pOppppppppppp4p3p    EEEEoD     ",
"pONMLKJTWXZZ24pp    ########    ",
"ppppppppppppppp    #lmkjbfgg#   ",
"                  #njjnjbfgg#   ",
"    ##############bbcncjbfgg#   ",
"    #5gggfebbcnjnbef########    ",
"     #hggfeebdnjnbf#  #bf#      ",
"      #############   ####      ",
"               #    ##j6eg##  # ",
"              #c#####lmcegg###c#",
"              #m#   #lmnbfg# #m#",
"               #    o######o  # "};

static const char * text_file_icon[]={
"32 32 5 1",
"b c #808080",
"c c #c3c3c3",
"# c #000000",
"  c None",
"a c #ffffff",
"     ##a##a##a##a##a##a##a#     ",
"    babbabbabbabbabbabbabbab#   ",
"   ba#aa#aa#aa#aa#aa#aa#aab#c#  ",
"   ba#aa#aa#aa#aa#aa#aa#aab#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baa######aaaaaaa#a###aac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baa######aaaaaaaaaaaaaac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baa######aaaaaaaaaaaaaac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baa##################aac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baa##################aac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baa##################aac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baa##################aac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baa######aaaaaaaaaaaaaac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baa######aaaaaaaaaaaaaac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"   baaaaaaaaaaaaaaaaaaaaaac#c#  ",
"    bccccccccccccccccccccc#c#   ",
"     #######################    "};

static const char * tgz_file_icon[]={
"32 32 32 1",
"s c #808080",
"i c #b0d7c8",
"f c #60cfff",
"w c #2f2f2f",
"u c #909090",
"j c #003060",
"C c #bbbbbb",
"g c #9fcfff",
"t c #676767",
"D c #00309f",
"d c #30cfcf",
"r c #b2b2b2",
"p c #000000",
"x c #3e3e3e",
"k c #a0cff0",
"e c #60cfcf",
"v c #101010",
"o c #e5e5e5",
"# c #003030",
"q c #202020",
"B c #050505",
"n c #cfefff",
"m c #60ffff",
"b c #009fcf",
"  c None",
"c c #309fcf",
"y c #606060",
"a c #00609f",
"l c #ffffff",
"A c #4d4d4d",
"h c #609fcf",
"z c #d1d1d1",
"      ##############            ",
"     #abbcdeefgggeeh#           ",
"    #abbbcdeefggggegi#######    ",
"    jjjjjjjjjjjjjj#kllmngdbb#   ",
"                   #nlmngdbb#   ",
"   oppppppppppppp   #lllgebb#   ",
"   qrrrrrrrrrrrrp    #######    ",
"   prrooospqtoorp     upppp     ",
"   prropppppptorp    vvvvvq     ",
"   prrpoowpspworp    xxxyy      ",
"   prpoootppptorp     #ne#      ",
"   pprooootwtoorp     upppp     ",
"   ppszoooooooorp    vvvvvq     ",
"   ppysoooooooorp    xxxyy      ",
"   ppszoozAwAzorp     #ne#      ",
"   pproozApppAzrp     upppp     ",
"   pprooAppsppxrp    vvvvvq     ",
"   pproowpsAspqrp    xxxyy      ",
"   pprooAppsppxrp     #ne#      ",
"   prppozwpppBCrp     #pppp     ",
"   prropppxqxClrp    vvvvjq     ",
"   prrrrrrrrrrrrp   ########    ",
"   oppppppppppppp  #llmnecbb#   ",
"                  #knnknecbb#   ",
"    ##############eegkgnecbb#   ",
"    #Dbbbcdeegknkedc########    ",
"     #abbcddefknkec#  #ec#      ",
"      #############   ####      ",
"               #    ##nidb##  # ",
"              #g#####llgdbb###g#",
"              #l#   #llkecb# #l#",
"               #    j######j  # "};

static const char * tar_file_icon[]={
"32 32 19 1",
"i c #c3c3c3",
"f c #b6b2b6",
"# c #000080",
"m c #494d49",
"h c #bebabe",
"p c #616561",
"n c #282c28",
"g c #000000",
"k c #616161",
"o c #383c38",
"a c #0000c0",
"c c #300000",
"d c #202020",
"  c None",
"b c #e7e7e7",
"e c #dcdcdc",
"q c #ffffff",
"l c #d7d3d7",
"j c #868286",
"                                ",
"     #a#a#a   #a   #a#a#        ",
"     a#a#a#  #a#a  a#a#a#       ",
"       #a   #a  #a #a  #a       ",
"       a#   a#  a# a#  a#       ",
"       #a   #a#a#a #a#a#        ",
"       a#   a#a#a# a#a#a        ",
"       #a   #a  #a #a a#a       ",
"       a#   a#  a# a#  a#a      ",
"                                ",
"                                ",
"       bcccccccccccccccde       ",
"       cfffggggggggffhhhgi      ",
"       cffgffffjkjfgffffgi      ",
"       cfbgbbbbljlbbgbbfgi      ",
"       cfgbbbbbbbbbbbgbfgi      ",
"       cfglmnmlbbbbbbgbfgi      ",
"       cfgngggmlbbbbbgbfgi      ",
"       cfoggjggmbbbpngjfgi      ",
"       cfdgjmjndbbpggggfgi      ",
"       cfoggjgdmbbngjgdfgi      ",
"       cfhmggdmbbbpgggpfgi      ",
"       cfqhmdmbbbbbpnpbfgi      ",
"       cffffffffffhhhhhhgi      ",
"       ggggggggggggggggggi      ",
"        iiiiiiiiiiiiiiiiii      ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
"                                "};

static const char * tex_file_icon[] = {
"32 32 5 1",
"       s None  c None",
".      c #808080",
"X      c white",
"o      c black",
"O      c #c0c0c0",
"    ...................         ",
"    .XXXXXXXXXXXXXXXXX.o        ",
"    .XXXXXXXXXXXXXXXXX..o       ",
"    .XXXXXXXXXXXXXXXXX.O.o      ",
"    .XXXXXXXXXXXXXXXXX.XO.o     ",
"    .XXXXXXXXXXXXXXXXX.XXO.o    ",
"    .XXXXXXXXXXXXXXXXX.oooooo   ",
"    .XXXXXXXXXXXXXXXXXXXXXXOo   ",
"    .XXXXXXXXXXXXXXXXXXXXXXOo   ",
"    .XXXXXXXXXXXXXXXXXXXXXXOo   ",
"    .XXXXXXXXXXXXXXXXXXXXXXOo   ",
"    .XooooooooXXXXooooXoooXOo   ",
"    .Xo.OooO.oOXXXXooOOOoOOOo   ",
"    .XoOXooOXoOXXXXOooXoOOXOo   ",
"    .XXOXooOXXOXXXXX.ooXOXXOo   ",
"    .XXXXooOXXXXXXXXXooOXXXOo   ",
"    .XXXXooOooooooXXooo.XXXOo   ",
"    .XXXXooOXooOOoOOoOooOXXOo   ",
"    .XXXXooOXoo..XOoOXXooXXOo   ",
"    .XXXooooOooo.OoooOooooXOo   ",
"    .XXXXOOOOoo..OXOOOXOOOOOo   ",
"    .XXXXXXXXooOOoXXXXXXXXXOo   ",
"    .XXXXXXXooooooOXXXXXXXXOo   ",
"    .XXXXXXXXOOOOOOXXXXXXXXOo   ",
"    .XXXXXXXXXXXXXXXXXXXXXXOo   ",
"    .XXXXXXXXXXXXXXXXXXXXXXOo   ",
"    .XXXXXXXXXXXXXXXXXXXXXXOo   ",
"    .XXXXXXXXXXXXXXXXXXXXXXOo   ",
"    .XXXXXXXXXXXXXXXXXXXXXXOo   ",
"    .XXXXXXXXXXXXXXXXXXXXXXOo   ",
"    .OOOOOOOOOOOOOOOOOOOOOOOo   ",
"    ooooooooooooooooooooooooo   "};

static const char * image_file_icon[]={
"32 32 27 1",
"b c #808080",
"l c #c3c3c3",
"u c #000080",
"d c #fffff0",
"t c #004000",
"m c #ffc0c0",
"q c #c0c0ff",
"s c #000000",
"i c #f0f0f0",
"e c #9f9f9f",
"g c #e0e0d0",
"o c #c0ffc0",
"h c #303030",
"w c #800000",
"f c #cfcfcf",
"y c #ffffc0",
"r c #0000ff",
"  c None",
"c c #505050",
"v c #585858",
"j c #efefef",
"x c #a0a0a4",
"p c #00c000",
"k c #dcdcdc",
"a c #ffffff",
"n c #ff0000",
"# c #707070",
"    ##################          ",
"    #aaaaaaaaaaaaaaaabc         ",
"    #adddddddddddddddbec        ",
"    #adddddddddddddddbfec       ",
"    #adddddddddddddddbgfec      ",
"    #adddddddddddddddbagfec     ",
"    #adddddddddddddddchhhhhh    ",
"    #adddddaaaaddaddijklee#c    ",
"    #adddddddaaddadidijkleec    ",
"    #addddddddadddddiiijklec    ",
"    #addddddddadaddidiijjklc    ",
"    #addddddddddaaidiiijjjfc    ",
"    #adddddddddddddiiijjjgfc    ",
"    #addddmnnmoppoqrqdajggfc    ",
"    #adddsnnnnppptrrrusjjgfc    ",
"    #adddsvnnnwpptrruusjggfc    ",
"    #adddsvbnnwpptxruvsgjgfc    ",
"    #adddsvbnwlaptxruvsjggfc    ",
"    #adddsvbnwlaptxuuvsgggfc    ",
"    #adddsvbnwlattxxbvsjggfc    ",
"    #adddsvbnwlaylxxbvsgggfc    ",
"    #adddsvbwwlaylxxbvsgggfc    ",
"    #adddsvbbxlaylxxbvsgggfc    ",
"    #addisvbbxlaylxxbvsgggfc    ",
"    #adiddsbbxlaylxxbvsgggfc    ",
"    #adddidsssssssssssggggfc    ",
"    #aididijiijjjgjgjgggggfc    ",
"    #adidijijjgjgjgjggggggfc    ",
"    #aiiijijggjgjgggggggggfc    ",
"    #jjjjjjgjgggggggggggggfc    ",
"    #ffffffffffffffffffffffc    ",
"    #ccccccccccccccccccccccc    "};

/*
 *
 *
 */

static QPixmap *iconFolderLocked = 0;
static QPixmap *iconFolder = 0;

static QPixmap *iconFile = 0;
static QPixmap *iconCFile = 0; 
static QPixmap *iconCppFile = 0;
static QPixmap *iconHFile = 0;
static QPixmap *iconIfFile = 0;
static QPixmap *iconM4File = 0;
static QPixmap *iconXFile = 0;
static QPixmap *iconAutFile = 0;
static QPixmap *iconDviFile = 0;
static QPixmap *iconHtmlFile = 0;
static QPixmap *iconJavaFile = 0;
static QPixmap *iconMakeFile = 0;
static QPixmap *iconOFile = 0;
static QPixmap *iconLFile = 0;
static QPixmap *iconYFile = 0;
static QPixmap *iconPdfFile = 0;
static QPixmap *iconPsFile = 0;
static QPixmap *iconReadmeFile = 0;
static QPixmap *iconZipFile = 0;
static QPixmap *iconTextFile = 0;
static QPixmap *iconTgzFile = 0;
static QPixmap *iconTarFile = 0;
static QPixmap *iconTexFile = 0;
static QPixmap *iconImageFile = 0;

static QPixmap *iconLink = 0;

void createPixmaps() 
{
    if ( iconFolderLocked )
        return;
 
    qAddPostRoutine( deletePixmaps );

    iconFolderLocked = new QPixmap( folder_locked_icon );
    iconFolder = new QPixmap( folder_icon );
    iconFile = new QPixmap( file_icon );
    iconCFile = new QPixmap( c_file_icon );
    iconCppFile = new QPixmap( cpp_file_icon );
    iconHFile = new QPixmap( h_file_icon );
    iconIfFile = new QPixmap( if_file_icon );
    iconM4File = new QPixmap( m4_file_icon );
    iconAutFile = new QPixmap( aut_file_icon );
    iconXFile = new QPixmap( x_file_icon );
    iconDviFile = new QPixmap( dvi_file_icon );
    iconHtmlFile = new QPixmap( html_file_icon );
    iconJavaFile = new QPixmap( java_file_icon );
    iconMakeFile = new QPixmap( make_file_icon );
    iconOFile = new QPixmap( o_file_icon );
    iconLFile = new QPixmap( l_file_icon );
    iconYFile = new QPixmap( y_file_icon );
    iconPdfFile = new QPixmap( pdf_file_icon );
    iconPsFile = new QPixmap( ps_file_icon );
    iconReadmeFile = new QPixmap( readme_file_icon );
    iconZipFile = new QPixmap( zip_file_icon );
    iconTextFile = new QPixmap( text_file_icon );
    iconTgzFile = new QPixmap( tgz_file_icon );
    iconTarFile = new QPixmap( tar_file_icon );
    iconTexFile = new QPixmap( tex_file_icon );
    iconImageFile = new QPixmap( image_file_icon );
   
    iconLink = new QPixmap( link_icon );
}

void deletePixmaps()
{
    delete iconFolderLocked;
        iconFolderLocked = 0;
    delete iconFolder;

    delete iconFile;
    delete iconCFile;
    delete iconCppFile;
    delete iconHFile;
    delete iconIfFile;
    delete iconM4File;
    delete iconAutFile;
    delete iconXFile;
    delete iconDviFile;
    delete iconHtmlFile;
    delete iconJavaFile;
    delete iconMakeFile;
    delete iconOFile;
    delete iconLFile;
    delete iconPdfFile;
    delete iconPsFile;
    delete iconReadmeFile;
    delete iconZipFile;
    delete iconTextFile;
    delete iconTgzFile;
    delete iconTarFile;
    delete iconTexFile;
    delete iconImageFile;

    delete iconLink;
}

QPixmap* getPixmap(QFileInfo* fi) {
    if ( fi->isDir() )
        return QDir ( fi->filePath()).isReadable() ? iconFolder : iconFolderLocked;
    else if (fi->isSymLink())
        return iconLink;
    else {
        QString extension = fi->extension( FALSE );

	if (extension == "c")
	  return iconCFile;
	if (extension == "C" || extension == "cpp" || extension == "cxx")
	  return iconCppFile;
	if (extension == "h" || extension == "hxx")
	  return iconHFile;
	if (extension == "if")
	  return iconIfFile;
	if (extension == "m4")
	  return iconM4File;
	if (extension == "aut")
	  return iconAutFile;
	if (extension == "x")
	  return iconXFile;
 	if (extension == "dvi")
	  return iconDviFile;
 	if (extension == "html" || extension == "htm")
	  return iconHtmlFile;
 	if (extension == "java")
	  return iconJavaFile;
 	if (extension == "o")
	  return iconOFile;
 	if (extension == "l")
	  return iconLFile;
 	if (extension == "y")
	  return iconYFile;
 	if (extension == "pdf")
	  return iconPdfFile;
 	if (extension == "ps" || extension == "eps")
	  return iconPsFile;
 	if (extension == "zip" || extension == "Z" || extension == "gz")
	  return iconZipFile;
 	if (extension == "txt")
	  return iconTextFile;
 	if (extension == "tgz")
	  return iconTgzFile;
 	if (extension == "tar")
	  return iconTarFile;
 	if (extension == "tex")
	  return iconTexFile;
	if (extension == "gif" || extension == "jpg" || extension == "jpeg")
	  return iconImageFile;
 
	if (fi->fileName() == "Makefile" || fi->fileName() == "makefile")
	  return iconMakeFile;
	if (fi->fileName() == "README" || fi->fileName() == "Readme")
	  return iconReadmeFile;

       return iconFile;
    }
}
