#ifndef TASKMANAGER_H
#define TASKMANAGER_H

#include <qwidget.h>
#include <qprocess.h>

class QProgressBar;
class QLabel;
class QComboBox;
class QToolButton;
class QTextEdit;

class TaskManager : public QWidget 
{
    Q_OBJECT

public:
    TaskManager( QWidget* parent, const char* name = 0, WFlags = 0);

public slots:
    void runTask( const QString & task );
    void directoryChanged( const QString & path);

protected:
    void setTaskCombo( const QString & task  );

    QProgressBar* progress;
    QLabel* label;
    QComboBox* taskCombo;
    QToolButton* stopButton, *clearButton;
    QTextEdit* log;
    QProcess* process;

protected slots:
    void stopTask();
    void clearLog();

    void readFromStderr();
    void readFromStdout();
    void processExited();

};

#endif
