#ifndef TOOLBOX_H
#define TOOLBOX_H

#include <qmainwindow.h>
#include <qiconview.h>
#include <qfileinfo.h>

#include "filebrowser.h"
#include "taskmanager.h"

#include "editor.h"

class Toolbox : public QMainWindow {
  Q_OBJECT

public:
  Toolbox();

protected:
  FileBrowser* fileBrowser;
  TaskManager* taskManager;
  
  EditorMainWindow* editor;

  QFileInfo* openFileInfo;
  QString ifPath;

protected slots:
  void contextMenu( QIconViewItem*, const QPoint& );

  void open(); 

  void compile();
  void generate();
  void optimize();

  void lash();
  void trex();

  void minimize();
  void visualize();

  void empty() {} 

};

#endif
